#!/bin/sh
# To install Athene, simply login as root and run the following command
# from the install directory:
#
#    sh install.sh
#
# If the installation process fails, check the install.txt file
# in the documents directory.

VERATHENE="athene-4.1"
VERPANDORA="pandora-2004.8"
HOMEDIR="/usr/local/share/$VERATHENE"
PANDORA="/usr/local/share/$VERPANDORA"
HOMELINK="/usr/local/athene"
PANDORALINK="/usr/local/pandora"

mkdir -m 775 -p "$HOMEDIR"
mkdir -m 775 -p "$PANDORA"
cp -pr documents "$HOMEDIR/"
cp -pr pictures "$HOMEDIR/"
cp -pr packages "$HOMEDIR/"
cp -pr programs "$HOMEDIR/"
cp -pr system "$PANDORA/"
ln -f -n -s "share/$VERATHENE" "$HOMELINK"
ln -f -n -s "share/$VERPANDORA" "$PANDORALINK"
ln -f -s ../athene/programs/bin/athene /usr/local/bin/athene
ln -f -s ../athene/programs/bin/athene-xserver /usr/local/bin/athene-xserver
ln -f -s ../athene/programs/bin/runscript /usr/local/bin/rundml
ln -f -s /usr/X11R6/lib /usr/local/athene/programs/x11/lib

chgrp -R root "$HOMEDIR" "$PANDORA"
chown -R root "$HOMEDIR" "$PANDORA"

chmod u+s "$HOMEDIR/programs/bin/athene" \
          "$HOMEDIR/programs/bin/runscript" \
          "$HOMEDIR/programs/bin/miniplayer" \
          "$HOMEDIR/programs/bin/findfiles" \
          "$HOMEDIR/programs/x11/bin/Xpandora"

if ! [ -f /usr/X11R6/lib/libX11.so ]; then \
   if [ -f /usr/X11R6/lib/libX11.so.6 ]; then ln -s libX11.so.6 /usr/X11R6/lib/libX11.so ; \
   elif [ -f /usr/X11R6/lib/libX11.so.6.2 ]; then ln -s libX11.so.6.2 /usr/X11R6/lib/libX11.so ; \
   elif [ -f /usr/X11R6/lib/libX11.so.6.1 ]; then ln -s libX11.so.6.1 /usr/X11R6/lib/libX11.so ; \
   fi \
fi

/usr/local/athene/programs/bin/x11scan
echo ""
more "$HOMELINK/documents/readme.txt"
